.* Control windows library - Asua Controls
.* Main documentation file
.* (c) 1999-2001 Wojciech Gazda
.*
.* asuactl.ipf
.*
.* $Author: gazda $
.* $Date: 2001/04/28 01:30:50 $
.* $Name:  $
.* $RCSfile: asuactl.ipf,v $
.* $Revision: 1.5 $
.*
.*
.* Opisy nowych kontrolek prosz pisa w osobnych plikach *.inc i dodawa je za pomoc
.* dyrektywy .im w zaznaczonym miejscu (prosz zachowywa alfabetyczn kolejno tytuw)

:userdoc.
:docprof toc=123456.
:title.asuactl.dll - Zestaw okien kontrolnych Asua


.* Rozdzia 1 - Wstp
.*
:h1 res=001.Wstp
:p.Biblioteka asuactl.dll zawiera kod obsugujcy szereg rodzajw okien
kontrolnych, pozbawionych jednoczenie wad ich odpowiednikw systemowych.
Biblioteka, ta zawiera take zupenie nowe klasy okien, ktrych nie ma w systemie.





.* Rozdzia 1.1 - Jak korzysta z okien
.*
:h2 res=011.Jak korzysta z okien
:p.Aby mona byo uy okien kontrolnych zawartych w pliku asuactl.dll, naley przed
uyciem bibliotek doczy do programu i zarejestrowa nowe klasy okien.
:p.Plik ready.zip zawiera wszystko, co niezbdne do wykorzystania nowych
okien kontrolnych. Powinny si w nim znajdowa pliki:
:dl tsize=5 break=all.
:dt.:hp2.asuactl.dll:ehp2.
:dd.Plik ten zawiera definicje wszystkich nowych klas okien.
:dt.:hp2.asuactl.lib:ehp2.
:dd.Jest to biblioteka symboli eksportowanych, ktr naley doczy do
programu korzystajcego z okien kontrolnych Asua.
:dt.:hp2.asuactl.h:ehp2.
:dd.Plik nagwkowy, zawierajcy wszystkie deklaracje niezbdne do prawidowej
kompilacji programw korzystajcych z okien kontrolnych. W kodzie rdowym programu
naley umieci odwoanie tylko do tego pliku - pozostae pliki *.h zawarte w katalogu
"ready" s doczane automatycznie podczas kompilacji asuactl.h.
:dt.:hp2.pozostae pliki *.h:ehp2.
:dd.Zawieraj one deklaracje komunikatw, staych i struktur danych poszczeglnych okien
kontrolnych. Pliki te musz si znale w tym samym katalogu co asuactl.h.
:edl.

:p.Inicjacji kodu mona dokona na dwa sposoby&colon.
:ol.
:li.Do programu naley doczy bibliotek asuactl.lib, a w kodzie progamu
umieci wywoanie funkcji
:link reftype=hd refid=ASUCTLINITIALIZE.AsuCtlInitialize:elink.,
ktra zarejstruje wszystkie klasy okien. Aby uy tego sposobu inicjacji,
biblioteka musi si znajdowa na systemowej ciece LIBPATH.

:li.W programie naley umieci nastpujcy fragment kodu, ktury zaaduje do pamici
bibliotek asuactl.dll i j zainicjuje:
:cgraphic.
// Zmienne globalne programu
HMODULE asuactl;    // Uchwyt moduu
HAB     anchor;     // Wynik wywoania WinInitialize	


// Inicjacja biblioteki asuactl.dll - fragment np. main()
{ LONG _syscall (*Init)(HAB hab);

  asuctl = NULLHANDLE;
  rc = DosLoadModule(NULL, 0L, "ASUACTL", &amp.asuactl);
  if(asuctl != NULLHANDLE)
  { // Odczyt adresu funkcji inicjujcej
    rc = DosQueryProcAddr(asuctl, 0, "ASUCTLINITIALIZE", &amp.Init);
    if(Init != NULL) rc = Init(anchor);
  }
}
:ecgraphic.

:p.Po poprawnym wykonaniu, zmienna rc (typu LONG) powinna zawiera zero.
Przed zakoczeniem programu modu asuactl.dll trzeba usun z pamici za pomoc
funkcji DosFreeModule.
:p.Przy tym sposobie inicjacji, biblioteka moe si znajdowa
w dowolnym miejscu na dysku, okrelonym za pomoc cieki dostpu przekazanej
funkcji DosLoadModule.
:eol.
:p.:hp8.Uwaga!:ehp8. W kodzie programu korzystajcego z asuactl.dll
nie naley definiowa staych&colon. __INTERNAL_USE__ i __BUILDING_LIBRARY__.




.* Rozdzia 2 - "Struktury danych oglnego przeznaczenia"
.*
.im common\doc\commdata.inc

.* Rozdzia 3 - Funkcje oglnego przeznaczenia
.*
.im common\doc\commfunc.inc



.* ***********************************************************
.* *** Add source documentation files for new windows here ***
.* ***********************************************************

.* WC_STATUS - Status window
.im status\doc\status.inc

.* WC_TOOLBAR - Toolbar
.im toolbar\doc\toolbar.inc

.* WC_WINBUTTON - Alternative button
.im winbutt\doc\winbutt.inc



.* ******************
.* *** Appendixes ***
.* ******************

.* Build and development procedures
.im common\doc\build.inc

:euserdoc.

.*
.* $Log: asuactl.ipf,v $
.* Revision 1.5  2001/04/28 01:30:50  gazda
.* Toolbar documentation added
.*
.* Revision 1.3  2001/04/25 22:05:45  gazda
.* Toolbar documentation added - 90%
.*
.* Revision 1.2  2001/03/19 20:38:05  gazda
.* Added english version of build procedures
.*
.* Revision 1.1  2001/03/11 17:41:50  Wojciech
.* Initial version
.*
.*
